package ca.uhn.fhir.test.utilities.server;

/*-
 * #%L
 * HAPI FHIR Test Utilities
 * %%
 * Copyright (C) 2014 - 2020 University Health Network
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import org.junit.jupiter.api.extension.AfterEachCallback;
import org.junit.jupiter.api.extension.BeforeEachCallback;
import org.junit.jupiter.api.extension.ExtensionContext;

public class ResourceProviderExtension implements BeforeEachCallback, AfterEachCallback {

	private final RestfulServerExtension myRestfulServerExtension;
	private Object myProvider;

	/**
	 * Constructor
	 */
	public ResourceProviderExtension(RestfulServerExtension theRestfulServerExtension, Object theProvider) {
		myRestfulServerExtension = theRestfulServerExtension;
		myProvider = theProvider;
	}

	@Override
	public void afterEach(ExtensionContext context) {
		myRestfulServerExtension.getRestfulServer().unregisterProvider(myProvider);
	}

	@Override
	public void beforeEach(ExtensionContext context) {
		myRestfulServerExtension.getRestfulServer().registerProvider(myProvider);
	}
}
